
; PICBASIC PRO(TM) Compiler 2.50c, (c) 1998, 2008 microEngineering Labs, Inc. All Rights Reserved.  
PM_USED			EQU	1

	INCLUDE	"16F84A.INC"

RAM_START       		EQU	0000Ch
RAM_END         		EQU	0004Fh
RAM_BANKS       		EQU	00001h
BANK0_START     		EQU	0000Ch
BANK0_END       		EQU	0004Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0213Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
FLAGS           		EQU	RAM_START + 012h
GOP             		EQU	RAM_START + 013h
RM1             		EQU	RAM_START + 014h
RM2             		EQU	RAM_START + 015h
RR1             		EQU	RAM_START + 016h
RR2             		EQU	RAM_START + 017h
_Imp             		EQU	RAM_START + 018h
_RPM             		EQU	RAM_START + 01Ah
T1              		EQU	RAM_START + 01Ch
_Time            		EQU	RAM_START + 01Eh
_Digit           		EQU	RAM_START + 020h
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTA
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISA
#define _PORTA??0        	 PORTA, 000h
#define _PORTA??1        	 PORTA, 001h
#define _PORTA??2        	 PORTA, 002h
#define _INTCON??1       	 INTCON, 001h
#define _INTCON??2       	 INTCON, 002h

; Constants.
_Tcon            		EQU	000F5h
	INCLUDE	"TAXOMETR.MAC"
	INCLUDE	"PBPPIC14.LIB"


	ASM?
 device PIC16F84A, HS_OSC, WDT_OFF, PWRT_ON, PROTECT_OFF

	ENDASM?

	MOVE?CB	000h, TRISA
	MOVE?CB	000h, PORTA
	MOVE?CB	001h, TRISB
	MOVE?CB	000h, PORTB
	MOVE?CW	_Tcon, _Time
	MOVE?CW	000h, _Imp
	MOVE?CW	000h, _RPM
	MOVE?CB	083h, OPTION_REG
	MOVE?CB	005h, TMR0
	MOVE?CB	0B0h, INTCON
	PAUSE?C	003E8h
	ONINT?LL	_myint, L00001

	LABEL?L	_Main	
	ICALL?L	L00001
	DIG?WCB	_RPM, 000h, _Digit
	ICALL?L	L00001
	MOVE?CT	001h, _PORTA??0
	ICALL?L	L00001
	MOVE?CT	000h, _PORTA??1
	ICALL?L	L00001
	MOVE?CT	000h, _PORTA??2
	ICALL?L	L00001
	GOSUB?L	_Look
	ICALL?L	L00001
	PAUSE?C	004h
	ICALL?L	L00001
	MOVE?CB	0FEh, PORTB
	ICALL?L	L00001
	DIG?WCB	_RPM, 001h, _Digit
	ICALL?L	L00001
	MOVE?CT	000h, _PORTA??0
	ICALL?L	L00001
	MOVE?CT	001h, _PORTA??1
	ICALL?L	L00001
	MOVE?CT	000h, _PORTA??2
	ICALL?L	L00001
	GOSUB?L	_Look
	ICALL?L	L00001
	PAUSE?C	004h
	ICALL?L	L00001
	MOVE?CB	0FEh, PORTB
	ICALL?L	L00001
	CMPGE?WCL	_RPM, 064h, L00003
	ICALL?L	L00001
	PAUSEUS?C	0012Ch
	ICALL?L	L00001
	GOTO?L	_Main
	ICALL?L	L00001
	LABEL?L	L00003	
	ICALL?L	L00001
	DIG?WCB	_RPM, 002h, _Digit
	ICALL?L	L00001
	MOVE?CT	000h, _PORTA??0
	ICALL?L	L00001
	MOVE?CT	000h, _PORTA??1
	ICALL?L	L00001
	MOVE?CT	001h, _PORTA??2
	ICALL?L	L00001
	GOSUB?L	_Look
	ICALL?L	L00001
	PAUSE?C	004h
	ICALL?L	L00001
	MOVE?CB	0FEh, PORTB
	ICALL?L	L00001
	GOTO?L	_Main
	DISABLE?	

	LABEL?L	_myint	
	CMPNE?TCL	_INTCON??1, 001h, L00005
	ADD?WCW	_Imp, 001h, _Imp
	MOVE?CT	000h, _INTCON??1
	LABEL?L	L00005	
	CMPNE?TCL	_INTCON??2, 001h, L00007
	SUB?WCW	_Time, 001h, _Time
	CMPNE?WCL	_Time, 000h, L00009
	MOVE?CW	_Tcon, _Time
	MUL?WCW	_Imp, 032h, T1
	DIV?WCW	T1, 00Ah, _RPM
	MOVE?CW	000h, _Imp
	LABEL?L	L00009	
	MOVE?CB	005h, TMR0
	MOVE?CT	000h, _INTCON??2
	LABEL?L	L00007	
	RESUME?	
	ENABLE?	

	LABEL?L	_Look	
	ICALL?L	L00001
	LOOKUP?BCLB	_Digit, 00Ah, L00002, PORTB
	LURET?C	080h
	LURET?C	0F2h
	LURET?C	048h
	LURET?C	060h
	LURET?C	032h
	LURET?C	024h
	LURET?C	004h
	LURET?C	0F0h
	LURET?C	000h
	LURET?C	020h

	LABEL?L	L00002	
	ICALL?L	L00001
	RETURN?	
	ICALL?L	L00001
	END?	

	END
